/***************************************************************************
 *            gui-fun.h
 *
 *  Sat Jul  9 13:25:13 2005
 *  Copyright  2005  User
 *  Email
 ****************************************************************************/

/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
 
#include <gtk/gtk.h>

#include "gui-fun.h"
#include "support.h"
#include "main-callbacks.h"

/*
 *	Funkcja tworzy prototyp listy 'main_view'
 */
 
void create_main_view ()	{
	GtkListStore 		*store;
    GtkCellRenderer 	*renderer;
    GtkTreeViewColumn 	*column;
	GtkWidget 			*treeview;
	
	treeview = (gpointer) lookup_widget (main_window, "main_tview");
	
	column = gtk_tree_view_column_new();
	renderer = gtk_cell_renderer_text_new ();
	
	gtk_tree_view_column_pack_start(column, renderer, TRUE);
	gtk_tree_view_column_add_attribute(column, renderer, "text", 0);
	gtk_tree_view_append_column(GTK_TREE_VIEW(treeview), column);
	gtk_tree_view_column_set_reorderable (GTK_TREE_VIEW_COLUMN (column), TRUE);
	gtk_tree_view_column_set_title (column, _("Book ID"));
	
	column = gtk_tree_view_column_new();
	renderer = gtk_cell_renderer_text_new ();
	
	gtk_tree_view_column_pack_start(column, renderer, TRUE);
	gtk_tree_view_column_add_attribute(column, renderer, "text", 1);
	gtk_tree_view_append_column(GTK_TREE_VIEW(treeview), column);
	gtk_tree_view_column_set_reorderable (GTK_TREE_VIEW_COLUMN (column), TRUE);
	gtk_tree_view_column_set_title (column, _("Title"));
	
	column = gtk_tree_view_column_new();
	renderer = gtk_cell_renderer_text_new ();
	
	gtk_tree_view_column_pack_start(column, renderer, TRUE);
	gtk_tree_view_column_add_attribute(column, renderer, "text", 2);
	gtk_tree_view_append_column(GTK_TREE_VIEW(treeview), column);
	gtk_tree_view_column_set_reorderable (GTK_TREE_VIEW_COLUMN (column), TRUE);
	gtk_tree_view_column_set_title (column, _("Lended"));
	
	store = gtk_list_store_new (3, G_TYPE_INT, G_TYPE_STRING, G_TYPE_STRING);
	
    gtk_tree_view_set_model (GTK_TREE_VIEW (treeview), GTK_TREE_MODEL(store));
}

/*
 *	Funkcja tworzy prototyp listy 'backup_yview'
 */

void		create_men_db_view		(GtkWidget	*widget)	{
	GtkListStore 		*store;
    GtkCellRenderer 	*renderer;
    GtkTreeViewColumn 	*column;
	GtkWidget 			*treeview;
	
	treeview = (gpointer) lookup_widget (widget, "men_db_tview");
	
	column = gtk_tree_view_column_new();
	renderer = gtk_cell_renderer_text_new ();
	
	gtk_tree_view_column_pack_start(column, renderer, TRUE);
	gtk_tree_view_column_add_attribute(column, renderer, "text", 0);
	gtk_tree_view_append_column(GTK_TREE_VIEW(treeview), column);
	gtk_tree_view_column_set_reorderable (GTK_TREE_VIEW_COLUMN (column), TRUE);
	gtk_tree_view_column_set_title (column, _("ID"));
	
	column = gtk_tree_view_column_new();
	renderer = gtk_cell_renderer_text_new ();
	
	gtk_tree_view_column_pack_start(column, renderer, TRUE);
	gtk_tree_view_column_add_attribute(column, renderer, "text", 1);
	gtk_tree_view_append_column(GTK_TREE_VIEW(treeview), column);
	gtk_tree_view_column_set_reorderable (GTK_TREE_VIEW_COLUMN (column), TRUE);
	gtk_tree_view_column_set_title (column, _("Author"));
		
	store = gtk_list_store_new (2, G_TYPE_INT, G_TYPE_STRING);
	
    gtk_tree_view_set_model (GTK_TREE_VIEW (treeview), GTK_TREE_MODEL(store));
}

/*
 *	Funkcja aktywuje/dezaktywuje widget
 *	Wartosci 'status':
 *		TRUE  - widget aktywny
 *		FALSE - widget nie aktywny
 */

void	set_widget_sensinitive (GtkWidget	*widget,
								gchar		*widget_name,
								gboolean	status)	
{
	GtkWidget	*tmp;
	tmp = (gpointer) lookup_widget (widget, widget_name);
	
	gtk_widget_set_sensitive (tmp, status);
}

/*
 *	Funkcja wyswietla tekst na widgecie 'main_statusbar'
 */

void		set_statusbar_text		(gchar		*text)	{
	GtkWidget	*widget;
	widget = (gpointer) lookup_widget (main_window, "main_stat_bar");
	
	gtk_statusbar_push (GTK_STATUSBAR (widget),
						gtk_statusbar_get_context_id (GTK_STATUSBAR (widget), text),
						text);
}

/*
 *	Funkcja przeladowuje 'main_tview'
 */

void	reload_main_view	(void)	{
	GtkTreeModel	*model;
	GtkTreeView		*tmp;
  	GtkTreeIter		iter;
	gboolean		status;
	
	tmp = (gpointer) lookup_widget (main_window, "main_tview");
	
	model = gtk_tree_view_get_model (tmp);
	
	gtk_list_store_clear (GTK_LIST_STORE (model));
	
	load_books_titles ();
}

/*
 *	Funkcja przeladowuje 'men_db_tview'
 */

void	reload_men_db_view	(GtkWidget	*widget)	{
	GtkTreeModel	*model;
	GtkTreeView		*tmp;
  	GtkTreeIter		iter;
	gboolean		status;
	
	tmp = (gpointer) lookup_widget (widget, "men_db_tview");
	
	model = gtk_tree_view_get_model (tmp);
	
	gtk_list_store_clear (GTK_LIST_STORE (model));
	
	load_authors (tmp);
}

/*
 *	Funkcja tworzy okno z ostrzezeniem, informacja, lub bledem.
 *	Wartosci zmiennej 'dlg_mode':
 *		0 - informacja
 *		1 - ostrzezeniem
 *		2 - blad
 */

void		show_message_dlg		(gchar		*text,
									 gint		dlg_mode)
{
	GtkWidget	*dialog;
	
	switch (dlg_mode)	{
		case 0:
			dialog = gtk_message_dialog_new (GTK_WINDOW (main_window),
											 GTK_DIALOG_DESTROY_WITH_PARENT,
        	    	                         GTK_MESSAGE_INFO,
            	    	                     GTK_BUTTONS_OK,
											 text);
			gtk_dialog_run (GTK_DIALOG (dialog));
			gtk_widget_destroy (dialog);
			break;
		case 1:
			dialog = gtk_message_dialog_new (GTK_WINDOW (main_window),
											 GTK_DIALOG_DESTROY_WITH_PARENT,
        	    	                         GTK_MESSAGE_WARNING,
            	    	                     GTK_BUTTONS_CLOSE,
											 text);
			gtk_dialog_run (GTK_DIALOG (dialog));
			gtk_widget_destroy (dialog);
			break;
		case 2:
			dialog = gtk_message_dialog_new (GTK_WINDOW (main_window),
											 GTK_DIALOG_DESTROY_WITH_PARENT,
        	    	                         GTK_MESSAGE_ERROR,
            	    	                     GTK_BUTTONS_CLOSE,
											 text);
			gtk_dialog_run (GTK_DIALOG (dialog));
			gtk_widget_destroy (dialog);
			break;
		default:
			g_printf ("(ERROR) Bad value of \'dlg_mode\' passed to \'show_message_dlg ()\'\n");
		}
}
