/***************************************************************************
 *            men_db-fun.c
 *
 *  Wed Jul 27 13:54:02 2005
 *  Copyright  2005  User
 *  Email
 ****************************************************************************/

/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#include "db-fun.h"
#include "men_db-fun.h"
#include "support.h"
#include "gui-fun.h"

/*
 *	Funkcja tworzy okno 'men_db_dlg' ustawiajac tresc etykiet itp. na adekwatna
 *	do edytowanej tabeli bazy danych.
 */

GtkWidget	*create_men_db_data_type	(void)	{
	GtkWidget	*dialog;
	GtkWidget	*tmp;
	
	selected_item_id = 0;
	
	dialog = (gpointer) create_menage_db_dlg ();
	
	switch (men_db_mode)	{
		case 1:
			gtk_window_set_title (GTK_WINDOW (dialog), _("Menage authors"));
			break;
	}
	
	tmp = (gpointer) lookup_widget (dialog, "men_db_top_lb");	
	switch (men_db_mode)	{
		case 1:
			gtk_label_set_markup (GTK_LABEL (tmp), _("<span size=\'large\'><b>Menaging authors</b></span>"));
			break;
	}
	
	tmp = (gpointer) lookup_widget (dialog, "men_db_down_lb");	
	switch (men_db_mode)	{
		case 1:
			gtk_label_set_text (GTK_LABEL (tmp), _("Now you can menage your author base by adding or removing them. Only author \'Somebody\' can't be removed. \"He\" is default author in GBiblioteka."));
			break;
	}
	
	tmp = (gpointer) lookup_widget (dialog, "men_db_entry_lb");	
	switch (men_db_mode)	{
		case 1:
			gtk_label_set_markup (GTK_LABEL (tmp), _("<b>First and last name of author</b>"));
			break;
	}
	
	set_widget_sensinitive (dialog, "men_db_add_but", FALSE);
	set_widget_sensinitive (dialog, "men_db_rem_but", FALSE);

	return dialog;	
}

/*
 *	Funkcja wczytuje tytuly filmow do listy 'main_view' z bazy danych
 */

void	load_authors	(GtkWidget	*widget)	{
	GtkTreeView			*treeview;
	GtkTreeModel		*store;
	GtkTreeIter 		iter;	
	gint				status = 0;
	gint				rows;
	gchar				*lended;
	sqlite3_stmt		*db_row;
		
	treeview = (gpointer) lookup_widget (widget, "men_db_tview");
	store = gtk_tree_view_get_model (GTK_TREE_VIEW (treeview));
	
	switch (men_db_mode)	{
		case 1:
			g_printf(">>> Loading authors, counting authors...\n");
			rows = count_returned_rows ("SELECT id FROM authors;");
			g_printf ("<<< Authors in data base: %d\n", rows);
	
			sqlite3_prepare(db_handler, "SELECT id, author FROM authors;", -1, &db_row, 0);	
			status = sqlite3_step (db_row);
			
			g_printf ("\t<<< Got first author, SQLite result: %d\n", status);
			break;
	}
	if (rows > 0)	{
		while (status == 100)		{
			gtk_list_store_append (GTK_LIST_STORE (store), &iter);
			gtk_list_store_set (GTK_LIST_STORE (store), &iter,
								0, sqlite3_column_int (db_row, 0), 
								1, sqlite3_column_text (db_row, 1),
								-1);
			status = sqlite3_step (db_row);
		}
		switch (men_db_mode)	{
			case 1:
				g_printf ("\t<<< Got last author, SQLite result: %d\n", status);
				break;
		}
	}
	
	sqlite3_finalize (db_row);
}

/*
 *	Funkcja dodaje pozycje do bazy danych
 */

void		add_item_to_database		(GtkWidget	*widget)	{
	GtkWidget		*tmp;
	sqlite3_stmt	*db_row;
	gchar			sql_query[128];
	gint			status;
	
	tmp = (gpointer) lookup_widget (widget, "men_db_en");
	switch (men_db_mode)	{
		case 1:
			g_sprintf (sql_query, "INSERT INTO authors (id, author) VALUES (NULL, \'%s\');",
								  gtk_entry_get_text (GTK_ENTRY (tmp)));
			break;
	}
	sqlite3_prepare(db_handler, sql_query, -1, &db_row, 0);	
	status = sqlite3_step (db_row);
	switch (men_db_mode)	{
		case 1:
			g_printf ("<<< Adding new author, SQLite result: %d\n", status);
			break;
	}
	gtk_entry_set_text (GTK_ENTRY (tmp), "");
	sqlite3_finalize (db_row);
}

/*
 *	Funkcja sprawdza czy 'selected_item_id'
 *		- jest rowny '1', jezeli tak wyswietla komuniokat i konczy dzialanie
 *		- jest uzyty w tabelo 'books' w kolumnie 'author' jezeli jest uzyty
 *		  uruchamia okno 'men_db_rem_dlg'
 */

void		check_if_item_used				(void)	{
	sqlite3_stmt	*db_row;
	gchar			string	[128];
	gint			status;
	gint			rows;
	
	if (selected_item_id == 1)	{
		show_message_dlg (_("This item is protected and it can't be removed!"), 2);
	}
	else if (selected_item_id == 0)	{
		/* if 'selected_item_id' jest rowne '0' nic nie robimy */
	}
	else	{
		switch (men_db_mode)	{
			case 1:
				g_sprintf (string, "SELECT title FROM books WHERE author=\'%d\';", selected_item_id);	
				break;
		}
		rows = count_returned_rows (string);
		if (rows == 0)	{
			rem_item_from_database ();
		}
		else	{
			GtkWidget		*dialog;
			GtkWidget		*tmp;
			
			dialog = (gpointer) create_men_db_rem_data_type ();			
			tmp = (gpointer) lookup_widget (dialog, "men_db_rem_books_lb");
			
			sqlite3_prepare(db_handler, string, -1, &db_row, 0);	
			status = sqlite3_step (db_row);
			
			if (status == 101)	{
				gtk_label_set_text (GTK_LABEL (tmp), sqlite3_column_text (db_row, 0));
			}
			else	{
				while (status == 100)	{
					g_sprintf (string, "%s\n%s", 
									   sqlite3_column_text (db_row, 0),
									   gtk_label_get_text (GTK_LABEL (tmp)));
					gtk_label_set_text (GTK_LABEL (tmp), string);
					status = sqlite3_step (db_row);
				}
			}
			
			gtk_widget_show (dialog);
			sqlite3_finalize (db_row);
		}
	}
}

/*
 *	Funkcja usuwa pozycje z bazy danych o ID 'selected_item_id'. 
 */

void		rem_item_from_database		(void)	{
	sqlite3_stmt	*db_row;
	gchar			sql_query[64];
	gint			status;
	
	if (selected_item_id == 1)	{
		show_message_dlg (_("This item is protected and it can't be removed!"), 2);
	}
	else if (selected_item_id == 0)	{
		/* if 'selected_item_id' jest rowne '0' nic nie robimy */
	}
	else	{
		switch (men_db_mode)	{
			case 1:
				g_sprintf (sql_query, "DELETE FROM authors WHERE id=\'%d\';",
									  selected_item_id);
				break;
		}
		sqlite3_prepare(db_handler, sql_query, -1, &db_row, 0);	
		status = sqlite3_step (db_row);
		switch (men_db_mode)	{
			case 1:
				g_printf ("<<< Removing author, SQLite result: %d\n", status);
				break;
		}
		sqlite3_finalize (db_row);
	}
	selected_item_id = 0;
}


/*
 *	Funkcja tworzy okno 'men_db_rem_dlg' ustawiajac tresc etykiet itp. na adekwatna
 *	do edytowanej tabeli bazy danych.
 */

GtkWidget	*create_men_db_rem_data_type	(void)	{
	GtkWidget	*dialog;
	GtkWidget	*tmp;
	
	dialog = (gpointer) create_men_db_rem_dlg ();
	
	gtk_window_set_title (GTK_WINDOW (dialog), _("Warning"));
	
	tmp = (gpointer) lookup_widget (dialog, "men_db_rem_top_lb");	
	switch (men_db_mode)	{
		case 1:
			gtk_label_set_markup (GTK_LABEL (tmp), _("<span size=\'large\'><b>Removing author</b></span>"));
			break;
	}
	
	tmp = (gpointer) lookup_widget (dialog, "men_db_rem_down_lb");	
	switch (men_db_mode)	{
		case 1:
			gtk_label_set_text (GTK_LABEL (tmp), _("Author, which you are removing at the moment is used by some books (listed below) in your database. Gbiblioteka can remove this author adn change author in all inconvenient books on \'Other\', do you want to continue?"));
			break;
	}
	tmp = (gpointer) lookup_widget (dialog, "men_db_rem_expander_lb");	
	switch (men_db_mode)	{
		case 1:
			gtk_label_set_markup (GTK_LABEL (tmp), _("<b>Inconvenient books</b>"));
			break;
	}
	
	tmp = (gpointer) lookup_widget (dialog, "men_db_rem_close_but");
	gtk_widget_hide (tmp);	

	return dialog;	
}

/*
 *	Funkcja aktualizuje baze danych w zaleznosci od wartosci zmiennej
 *	'men_db_mode'
 */

void		update_table_book				(GtkWidget	*widget)	{
	GtkWidget		*tmp;
	sqlite3_stmt	*db_row;
	gchar			string	[128];
	gint			status;
	
	tmp = (gpointer) lookup_widget (widget, "men_db_rem_no_but");
	gtk_widget_hide (tmp);
	tmp = (gpointer) lookup_widget (widget, "men_db_rem_yes_but");
	gtk_widget_hide (tmp);
	tmp = (gpointer) lookup_widget (widget, "men_db_rem_close_but");
	gtk_widget_show (tmp);
	set_widget_sensinitive (widget, "men_db_rem_close_but", FALSE);
	
	switch (men_db_mode)	{
		case 1:
			g_printf (">>> Updating table \'books\', SQLite result: ");
			g_sprintf (string, "UPDATE books SET author=\'1\' WHERE author=\'%d\';", selected_item_id);	
			break;
	}
	
	sqlite3_prepare(db_handler, string, -1, &db_row, 0);	
	status = sqlite3_step (db_row);
	sqlite3_finalize (db_row);
	g_printf ("%d\n", status);
	
	set_widget_sensinitive (widget, "men_db_rem_close_but", TRUE);
}
